
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


/*
 * Created on Feb 10, 2005
 */
package com.ibm.ccd.ui.dataobjects.items;

import java.util.ArrayList;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import com.ibm.ccd.ui.dataobjects.attributes.Attribute;
import com.ibm.ccd.ui.mediator.XMLHelper;


/**
 *
 */
public class CatalogViewParser {
    /**
     *
     */
    private Attribute[] itemSpecAttributes = null;
    private Element rootElement = null;

    public CatalogViewParser() {
        super();
    }

    public CatalogView getCatalogView(String specXML,
        Attribute[] pItemSpecAttributes) {
        Document document = null;
        CatalogView catalogView = null;

        Element element = null;
        Element[] elementArray = null;
        Element[] attribArray = null;
        Element[] attributeCollArray = null;
        ArrayList attributeList = null;
        String value = null;
        String tabName = null;
        String attributeCollection = null;
        ArrayList tempList = null;

        catalogView = new CatalogView();
        this.itemSpecAttributes = pItemSpecAttributes;

        XMLHelper helper = new XMLHelper();
        document = XMLHelper.parseFromFile("C:/temp/CATALOG_VIEW.xml");
        rootElement = document.getDocumentElement();

        elementArray = XMLHelper.getElements(rootElement, "Tab");

        for (int i = 0; i < elementArray.length; i++) {
            element = elementArray[i];
            tabName = XMLHelper.getAttributeValue(element, "name");

            attributeCollArray = XMLHelper.getElements(element,
                    "AttributeCollection");

            for (int j = 0; j < attributeCollArray.length; j++) {
                element = attributeCollArray[j];
                attributeCollection = element.getLastChild().getNodeValue();

                tempList = getAttributeList(attributeCollection);

                if (attributeList == null) {
                    attributeList = tempList;
                } else {
                    attributeList.addAll(tempList);
                }
            }

            catalogView.setTab(tabName, attributeList);
            attributeList = null;
        }

        return catalogView;
    }

    /**
     * @param attributeCollection
     */
    private ArrayList getAttributeList(String pAttributeCollection) {
        Element[] elementArray = null;
        Element element = null;
        Element[] attribArray = null;
        Attribute itemAttribute = null;
        String attributeCollection = null;
        String attributeName = null;
        ArrayList AttributeList = null;

        AttributeList = new ArrayList();
        elementArray = XMLHelper.getElements(rootElement, "ATTRIBUTE_COLS");

        for (int i = 0; i < elementArray.length; i++) {
            element = elementArray[i];
            attributeCollection = XMLHelper.getFirstElementValue(element, "Name");

            if (attributeCollection.equals(pAttributeCollection)) {
                attribArray = XMLHelper.getElements(element, "Attr");

                for (int j = 0; j < attribArray.length; j++) {
                    element = attribArray[j];
                    attributeName = XMLHelper.getAttributeValue(element, "name");
                    itemAttribute = getAttribute(attributeName);
                    AttributeList.add(itemAttribute);
                }
            }
        }

        return AttributeList;
    }

    /**
     * @param attributeName
     * @return
     */
    private Attribute getAttribute(String pAttributeName) {
        Attribute itemAttribute = null;
        String attributeName = null;

        for (int i = 0; i < itemSpecAttributes.length; i++) {
            itemAttribute = itemSpecAttributes[i];
            attributeName = itemAttribute.getName();

            if (attributeName.equals(pAttributeName)) {
                break;
            }
        }

        return itemAttribute;
    }
}
