
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


package com.ibm.ccd.ui.portlets.searchutil;

import java.io.IOException;

import org.apache.jetspeed.portlet.Portlet;
import org.apache.jetspeed.portlet.PortletException;
import org.apache.jetspeed.portlet.PortletRequest;
import org.apache.jetspeed.portlet.PortletResponse;
import org.apache.jetspeed.portlet.PortletSession;

import com.ibm.ccd.ui.context.WPSContext;
import com.ibm.ccd.ui.portlets.search.core.BaseSearchPortlet;
import com.ibm.ccd.ui.portlets.search.core.cmd.ISearchCommand;
import com.ibm.ccd.ui.portlets.searchutil.cmd.SearchUtilViewDataStoreCmd;


public class SearchUtilPortlet extends BaseSearchPortlet {
    protected void render(PortletRequest request, PortletResponse response,
        Portlet.Mode mode) throws PortletException, IOException {
        String jspName = null;

        if (Portlet.Mode.VIEW.equals(mode)) {
            jspName = ISearchUtil.PATH_SEARCH_VIEW_JSP;
        }

        if (Portlet.Mode.EDIT.equals(mode)) {
            jspName = ISearchUtil.PATH_SEARCH_EDIT_JSP;
        }

        if (Portlet.Mode.CONFIGURE.equals(mode)) {
            jspName = ISearchUtil.PATH_SEARCH_CONFIG_JSP;
        }

        if (Portlet.Mode.HELP.equals(mode)) {
        }

        includeJSP(jspName, request, response);
    }

    protected WPSContext getWPSContext(PortletRequest request) {
        PortletSession portletSession = null;
        WPSContext context = null;
        portletSession = request.getPortletSession();
        context = (WPSContext) portletSession.getAttribute(WPSContext.KEY_WPS_CONTEXT_BEAN);

        if (context == null) {
            context = createContext(request);
            portletSession.setAttribute(WPSContext.KEY_WPS_CONTEXT_BEAN, context);
        }

        return context;
    }

    protected ISearchCommand getDataStore(Portlet.Mode mode) {
        ISearchCommand command = null;

        if (Portlet.Mode.VIEW.equals(mode)) {
            command = new SearchUtilViewDataStoreCmd();
        } else {
            command = super.getDataStore(mode);
        }

        return command;
    }
}
