package com.ibm.ccd.ui.portlets.validation;

import java.io.IOException;

import org.apache.jetspeed.portlet.*;


/**
 *
 * A sample portlet based on PortletAdapter
 * 
 */
public class ValidationErrorPortlet extends PortletAdapter {

    public static final String VIEW_JSP         = "/jsps/html/validationError/ValidationErrorPortletView.";     // JSP file name to be rendered on the view mode


    /**
	 * @see org.apache.jetspeed.portlet.Portlet#init(PortletConfig)
	 */
	public void init(PortletConfig portletConfig) throws UnavailableException {
		super.init(portletConfig);
	}

	/**
	 * @see org.apache.jetspeed.portlet.PortletAdapter#doView(PortletRequest, PortletResponse)
	 */
	public void doView(PortletRequest request, PortletResponse response) throws PortletException, IOException {
       	// Invoke the JSP to render        		
	    getPortletConfig().getContext().include(VIEW_JSP+getJspExtension(request), request, response);
	}

	/**
	 * Returns the file extension for the JSP file
	 * 
	 * @param request PortletRequest
	 * @return JSP extension 
	 */
	private static String getJspExtension(PortletRequest request) {
		String markupName = request.getClient().getMarkupName();
		return "jsp";
	}
	
}
