
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


package com.ibm.ccd.ui.portlets.workflow;

import java.util.List;

import com.ibm.ccd.ui.dataobjects.attributes.Attribute;
import com.ibm.ccd.ui.dataobjects.workflow.ListboxContainer;
import com.ibm.ccd.ui.dataobjects.workflow.PageNavigation;
import com.ibm.ccd.ui.dataobjects.workflow.Workflow;


/**
 * Class holds data that needs to be rendered in jsp
 */
public class WorkflowBean {
    private ListboxContainer workflowList = null;
    private ListboxContainer teamList = null;
    private Workflow workflow = null;
    private List itemList = null;
    private PageNavigation pageNav = null;
    private Attribute attributePk = null;

    /*
     *  Variables required for reserve Edit function
     */
    private ReserveEditDataBean reserveEditBean = null;
    private String linktoWorkItem = null;
    private String primaryCatalog = null;
    private List dispAttributeList = null;

    /**
     * @return
     */
    public List getItemList() {
        return itemList;
    }

    /**
     * @return
     */
    public List getStepsList() {
        return workflow.getSteps();
    }

    /**
     * @param list
     */
    public void setItemList(List list) {
        itemList = list;
    }

    /**
     * @return
     */
    public PageNavigation getPageNav() {
        return pageNav;
    }

    /**
     * @return
     */
    public ListboxContainer getTeamList() {
        return teamList;
    }

    /**
     * @return
     */
    public ListboxContainer getWorkflowList() {
        return workflowList;
    }

    /**
     * @param navigation
     */
    public void setPageNav(PageNavigation navigation) {
        pageNav = navigation;
    }

    /**
     * @param container
     */
    public void setTeamList(ListboxContainer container) {
        teamList = container;
    }

    /**
     * @param container
     */
    public void setWorkflowList(ListboxContainer container) {
        workflowList = container;
    }

    /**
     * @return
     */
    public Workflow getWorkflow() {
        return workflow;
    }

    /**
     * @param workflow
     */
    public void setWorkflow(Workflow workflow) {
        this.workflow = workflow;
    }

    /**
     * @return
     */
    public ReserveEditDataBean getReserveEditBean() {
        return reserveEditBean;
    }

    /**
     * @param bean
     */
    public void setReserveEditBean(ReserveEditDataBean bean) {
        reserveEditBean = bean;
    }

    /**
     * @return
     */
    public String getLinktoWorkItem() {
        return linktoWorkItem;
    }

    /**
     * @param string
     */
    public void setLinktoWorkItem(String string) {
        linktoWorkItem = string;
    }

    /**
     * @return
     */
    public String getPrimaryCatalog() {
        return primaryCatalog;
    }

    /**
     * @param string
     */
    public void setPrimaryCatalog(String string) {
        primaryCatalog = string;
    }

    /**
     * @return
     */
    public List getDispAttributeList() {
        return dispAttributeList;
    }

    /**
     * @param list
     */
    public void setDispAttributeList(List list) {
        dispAttributeList = list;
    }
    /**
     * @param attributePk The attributePk to set.
     */
    public void setAttributePk(Attribute attributePk) {
        this.attributePk = attributePk;
    }
    /**
     * @return
     */
    public String getPrimaryKeyName() {
        return attributePk.getName();
    }
    /**
     * @return
     */
    public String getPrimaryKeyLable() {
        return attributePk.getDisplayLabelName();
    }
}
