
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


package com.ibm.ccd.ui.tags.element;

import org.apache.jetspeed.portlet.PortletURI;

import com.ibm.ccd.ui.dataobjects.attributes.Attribute;
import com.ibm.ccd.ui.dataobjects.attributes.FlagAttribute;


public class FlagElement extends TextElement {
    public FlagElement(Attribute attribute, PortletURI portletURI) {
        super(attribute, portletURI);
    }

    public String renderElement() {
        StringBuffer buffer = new StringBuffer();

        if (attribute.isMultiValued()) {
            for (int i = 0; i < attribute.getCurrOccurrence(); i++) {
            	if(isShowLabel())
            		buffer.append(displayLabel());
                buffer.append(displayField(i, getStringValue(attribute, i)));
            }
        } else {
        	if(isShowLabel())
        		buffer.append(displayLabel());
            buffer.append(displayField(0, getStringValue(attribute, 0)));
        }

        return buffer.toString();
    }

    /**
     * @param id
     * @param value
     * @return
     */
    public String displayField(long id, String value) {
        StringBuffer buffer = new StringBuffer();
        addHTMLProperty(HTMLVALUE, value);

        String path = getAttributeID(String.valueOf(id));
        attribute.setPath(path);
        addHTMLProperty(HTMLID, path);

        addHTMLProperty(HTMLNAME, path);
        buffer.append(HTML_ATTRIBUTE_START);

        if (isEditable()) {
            buffer.append(HTML_SPACE).append(HTML_CHECKBOX)
                  .append(getHTMLValue(HTMLID)).append(getHTMLValue(HTMLNAME));

            if (value.equals(FLAG_TRUE)) {
                buffer.append(CHECKED);
            }
            if(showLabel)
				buffer.append(getHTMLValue(JS_EVENT_ONCHANGE));

            buffer.append(HTML_CLOSE_TAG);

            if (attribute.isMultiValued()) {
            	if(isShowLabel())
            		buffer.append(displayPlusMinus(id));
            }
        } else {
            buffer.append(value);
        }

        buffer.append(HTML_ATTRIBUTE_END);

        return buffer.toString();
    }

    /**
     * @param attribute
     * @param index
     * @return
     */
    protected String getStringValue(Attribute attribute, int index) {
        FlagAttribute flagAttrib = (FlagAttribute) attribute;

        if (flagAttrib.getCurrOccurrence() > 0) {
            String[] fvalues = flagAttrib.getValues();

            if (flagAttrib.isMultiValued()) {
                return (fvalues[index].equalsIgnoreCase("on")) ? "true"
                                                               : fvalues[index];
            } else {
                if (fvalues[0] == null) {
                    return "false";
                } else {
                    return (fvalues[0].equalsIgnoreCase("on")) ? "true"
                                                               : fvalues[index];
                }
            }
        } else {
            if (flagAttrib.getDefaultValue() != null) {
                return (flagAttrib.getDefaultValue().equalsIgnoreCase("on"))
                ? "true" : flagAttrib.getDefaultValue();
            } else {
                return "false";
            }
        }
    }
}
